# 필요 Package 설치
install.packages("rvest") #웹페이지 크롤링을 위한 패키징
library("rvest")

szPostUrl1 <- "http://www.itworld.co.kr/news/106768"
szPostData1 <- read_html(szPostUrl1)
# 전체 페이지 크롤링은 쉬우나, 특정 영역 크롤링은 간단하지 않으므로 우선 Pass, 다음에 실습 예정

# 필요 Package 설치
install.packages("KoNLP") #한글 자연어 처리 패키지 (Korean Natural Language Process)
install.packages("wordcloud") #wordcloud 패키지
install.packages("RColorBrewer")

# Library 로드
library("KoNLP")
library("wordcloud")
library("RColorBrewer")

# wordcloud2 로드해서 letter나 이미지배경 사용을 위해서 꼭 설치해야한다
require(devtools)
install_github("lchiffon/wordcloud2")
library("wordcloud2")

useSejongDic() #한글 세종사전

## 작업디렉토리 설정 및 파일 불러오기
setwd("/Users/jake/downloads/Homes")
szFileName <- "/Users/jake/downloads/Homes/data.txt"
szWordSaveFileName <- "/Users/jake/downloads/Homes/data_Word.txt"
szWordCloudImageFile <- "/Users/jake/downloads/Homes/data_Word.png"

szContents <- readLines(szFileName) # 기사를 담은 파일에서 한 라인씩 읽어들이기
szContents # 파일 내용 확인

# 불필요한 문자 필터링, 치환
szContents <- gsub("'","",szContents)
szContents <- gsub("‘","",szContents)
szContents <- gsub("“","",szContents)
szContents <- gsub("”","",szContents)


szNounsContents <- sapply(szContents, extractNoun, USE.NAMES=F) #각 라인마다 명사단어들만 남기기
szNounsContents
szNounsContentsList <- unlist(szNounsContents) #단어들만 가져오기
szNounsContentsList

# 2글자 이상의 단어만 필터링
szLastData <- Filter(function(x) {
nchar(x)>=2
},szNounsContentsList)

## 최종 2글자 이상의 단어들의 목록
szLastData 

write(szLastData, szWordSaveFileName) # 결과 목록을 파일로 저장

szDataTable <- read.table(szWordSaveFileName)
szDataTable

ListWordCount = table(szDataTable) # 테이블형태 변환해서 저장
ListWordCount ## 테이블 형태로 저장 (아래 그림3 참고)

display.brewer.all() # 제공 색상타입 모두 보기 (아래 그림4 참고)
## 폰트 추가
install.packages("dplyr") 
install.packages('tidyverse')
install.packages('showtext')
library(tidyverse)
library(showtext)
font_add_google("Nanum Gothic", "nanumgothic")

### Word Cloud 함수 호출
#wordcloud(
#names(ListWordCount),
#freq=ListWordCount,
#scale=c(5,0.2), #빈도가 가장 큰 단어와 가장 빈도가 작은단어 폰사 사이 크기
#rot.per=0.1, #90도 회전해서 보여줄 단어 비율
#min.freq=3, max.words=100, # 빈도 3이상, 100미만
#random.order=F, # True : 랜덤배치, False : 빈도수가 큰단어를 중앙에 배치
#random.color=T, # True : 색랜덤, False : 빈도순
#colors=brewer.pal(11, "Paired"), #11은 사용할 색상개수, 두번째는 색상타입이름
#family="font")

wordcloud2(ListWordCount, size=0.5, fontFamily='nanumgothic', color = "random-light",backgroundColor = "black")
wordcloud2(ListWordCount, figPath = "b.png", size = 1.5, fontFamily = 'nanumgothic')
wordcloud2(ListWordCount, figPath = "butter.png", size = 1.5, fontFamily='nanumgothic')
letterCloud(ListWordCount, word='H', wordSize = 1, fontFamily='nanumgothic', color = "random-light",backgroundColor = "white")
letterCloud(ListWordCount, word = "R", wordSize = 1, fontFamily='nanumgothic', color = "random-light", backgroundColor = "grey")



## 최종 이미지파일로 저장
savePlot(szWordCloudImageFile, type="png”)

